﻿Imports Infragistics.Win.UltraWinCalcManager
Imports Infragistics.Win.UltraWinGrid

Public Class Form1

    Dim unboundColumnKey As String = "Unbound Column"

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim types As Type() = New Type() {GetType(Integer), GetType(Integer), GetType(Integer)}
        Dim dt As DataTable = DummyDataCreator.GetData(5000, types)

        Me.UltraGrid1.DataSource = dt
    End Sub

    Private Sub UltraGrid1_InitializeLayout(sender As Object, e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles UltraGrid1.InitializeLayout
        Dim layout As UltraGridLayout = e.Layout
        Dim band0 As UltraGridBand = layout.Bands(0)
        Dim ov As UltraGridOverride = layout.Override

        band0.Columns("Int32 3").Formula = "[Int32 1] + [Int32 2]"


        Dim unboundColumn As UltraGridColumn
        If (band0.Columns.Exists(unboundColumnKey)) Then
            unboundColumn = band0.Columns(unboundColumnKey)
        Else
            unboundColumn = band0.Columns.Add(unboundColumnKey)
            unboundColumn.DataType = GetType(Integer)
        End If

        unboundColumn.Formula = "[Int32 1] + [Int32 2]"

    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        Dim row As UltraGridRow = Me.UltraGrid1.Rows(Me.UltraGrid1.Rows.Count - 1)
        Debug.WriteLine(row.Cells("Int32 3").Text)
        Debug.WriteLine(row.Cells(unboundColumnKey).Text)

    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        Try

            Me.UltraGrid1.CalcManager = Nothing
            Me.UltraCalcManager1.DeferredCalculationsEnabled = False
            Me.UltraGrid1.CalcManager = Me.UltraCalcManager1

            Me.UltraCalcManager1.CalcFrequency = CalcFrequency.Manual

            Me.UltraCalcManager1.ReCalc()
        Finally
            Me.UltraCalcManager1.DeferredCalculationsEnabled = True
            Me.UltraCalcManager1.CalcFrequency = CalcFrequency.Asynchronous
        End Try
    End Sub
End Class